Index: /palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_module.f90	(revision 4140)
+++ /palm/trunk/SOURCE/data_output_module.f90	(revision 4141)
@@ -250,411 +271,10 @@
 
    CALL binary_init_module( output_file_suffix, output_group_comm, master_rank, &
-                            debug_output_unit, debug_output, no_var_id )
+                            debug_output_unit, debug_output, no_id )
 
    CALL netcdf4_init_module( output_file_suffix, output_group_comm, master_rank, &
-                            debug_output_unit, debug_output, no_var_id )
+                            debug_output_unit, debug_output, no_id )
 
 END SUBROUTINE dom_init
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Debugging output. Print contents of output database to debug_output_unit.
-!--------------------------------------------------------------------------------------------------!
-SUBROUTINE dom_database_debug_output
-
-   CHARACTER(LEN=*), PARAMETER ::  separation_string = '---'                   !< string separating blocks in output
-   CHARACTER(LEN=50)           ::  format1                                     !< format for write statements
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_database_debug_output'  !< name of this routine
-
-   INTEGER            ::  f                       !< loop index
-   INTEGER, PARAMETER ::  indent_depth = 3        !< space per indentation
-   INTEGER            ::  indent_level            !< indentation level
-   INTEGER, PARAMETER ::  max_keyname_length = 6  !< length of longest key name
-   INTEGER            ::  natt                    !< number of attributes
-   INTEGER            ::  ndim                    !< number of dimensions
-   INTEGER            ::  nvar                    !< number of variables
-
-
-   CALL internal_message( 'debug', routine_name // ': write data base to debug output' )
-
-   WRITE( debug_output_unit, '(A)' ) 'DOM data base:'
-   WRITE( debug_output_unit, '(A)' ) REPEAT( separation_string // ' ', 4 )
-
-   IF ( .NOT. ALLOCATED( files ) .OR. nf == 0 )  THEN
-
-      WRITE( debug_output_unit, '(A)' ) 'database is empty'
-
-   ELSE
-
-      indent_level = 1
-      WRITE( format1, '(A,I3,A,I3,A)' ) '(T', indent_level * indent_depth + 1, ',A,T',        &
-                                        indent_level * indent_depth + 1 + max_keyname_length, &
-                                        ',(": ")'
-
-      DO  f = 1, nf
-
-         natt = 0
-         ndim = 0
-         nvar = 0
-         IF ( ALLOCATED( files(f)%attributes ) ) natt = SIZE( files(f)%attributes )
-         IF ( ALLOCATED( files(f)%dimensions ) ) ndim = SIZE( files(f)%dimensions )
-         IF ( ALLOCATED( files(f)%variables  ) ) nvar = SIZE( files(f)%variables  )
-
-         WRITE( debug_output_unit, '(A)' ) 'file:'
-         WRITE( debug_output_unit, TRIM( format1 ) // ',A)' ) 'name', TRIM( files(f)%name )
-         WRITE( debug_output_unit, TRIM( format1 ) // ',A)' ) 'format', TRIM( files(f)%format )
-         WRITE( debug_output_unit, TRIM( format1 ) // ',I7)' ) 'id', files(f)%id
-         WRITE( debug_output_unit, TRIM( format1 ) // ',L1)' ) 'is init', files(f)%is_init
-         WRITE( debug_output_unit, TRIM( format1 ) // ',I7)' ) '#atts', natt
-         WRITE( debug_output_unit, TRIM( format1 ) // ',I7)' ) '#dims', ndim
-         WRITE( debug_output_unit, TRIM( format1 ) // ',I7)' ) '#vars', nvar
-
-         IF ( natt /= 0 )  CALL print_attributes( indent_level, files(f)%attributes )
-         IF ( ndim /= 0 )  CALL print_dimensions( indent_level, files(f)%dimensions )
-         IF ( nvar /= 0 )  CALL print_variables( indent_level, files(f)%variables )
-
-         WRITE( debug_output_unit, '(/A/)' ) REPEAT( separation_string // ' ', 4 )
-
-      ENDDO
-
-   ENDIF
-
-   CONTAINS
-
-      !--------------------------------------------------------------------------------------------!
-      ! Description:
-      ! ------------
-      !> Print list of attributes.
-      !--------------------------------------------------------------------------------------------!
-      SUBROUTINE print_attributes( indent_level, attributes )
-
-         CHARACTER(LEN=50) ::  format1  !< format for write statements
-         CHARACTER(LEN=50) ::  format2  !< format for write statements
-
-         INTEGER             ::  i                       !< loop index
-         INTEGER, INTENT(IN) ::  indent_level            !< indentation level
-         INTEGER, PARAMETER  ::  max_keyname_length = 6  !< length of longest key name
-         INTEGER             ::  nelement                !< number of elements to print
-
-         TYPE(attribute_type), DIMENSION(:), INTENT(IN) ::  attributes  !< list of attributes
-
-
-         WRITE( format1, '(A,I3,A)' ) '(T', indent_level * indent_depth + 1, ',A'
-         WRITE( format2, '(A,I3,A,I3,A)' ) &
-            '(T', ( indent_level + 1 ) * indent_depth + 1, ',A,T', &
-            ( indent_level + 1 ) * indent_depth + 1 + max_keyname_length, ',(": ")'
-
-         WRITE( debug_output_unit, TRIM( format1 ) // ',A)' ) REPEAT( separation_string // ' ', 4 )
-         WRITE( debug_output_unit, TRIM( format1 ) // ')' ) 'attributes:'
-
-         nelement = SIZE( attributes )
-         DO  i = 1, nelement
-            WRITE( debug_output_unit, TRIM( format2 ) // ',A)' ) &
-               'name', TRIM( attributes(i)%name )
-            WRITE( debug_output_unit, TRIM( format2 ) // ',A)' ) &
-               'type', TRIM( attributes(i)%data_type )
-
-            IF ( TRIM( attributes(i)%data_type ) == 'char' )  THEN
-               WRITE( debug_output_unit, TRIM( format2 ) // ',A)' ) &
-                  'value', TRIM( attributes(i)%value_char )
-            ELSEIF ( TRIM( attributes(i)%data_type ) == 'int8' )  THEN
-               WRITE( debug_output_unit, TRIM( format2 ) // ',I4)' ) &
-                  'value', attributes(i)%value_int8
-            ELSEIF ( TRIM( attributes(i)%data_type ) == 'int16' )  THEN
-               WRITE( debug_output_unit, TRIM( format2 ) // ',I6)' ) &
-                  'value', attributes(i)%value_int16
-            ELSEIF ( TRIM( attributes(i)%data_type ) == 'int32' )  THEN
-               WRITE( debug_output_unit, TRIM( format2 ) // ',I11)' ) &
-                  'value', attributes(i)%value_int32
-            ELSEIF ( TRIM( attributes(i)%data_type ) == 'real32' )  THEN
-               WRITE( debug_output_unit, TRIM( format2 ) // ',E14.7)' ) &
-                  'value', attributes(i)%value_real32
-            ELSEIF (  TRIM(attributes(i)%data_type) == 'real64' )  THEN
-               WRITE( debug_output_unit, TRIM( format2 ) // ',E22.15)' ) &
-                  'value', attributes(i)%value_real64
-            ENDIF
-            IF ( i < nelement )  &
-               WRITE( debug_output_unit, TRIM( format1 ) // ')' ) separation_string
-         ENDDO
-
-      END SUBROUTINE print_attributes
-
-      !--------------------------------------------------------------------------------------------!
-      ! Description:
-      ! ------------
-      !> Print list of dimensions.
-      !--------------------------------------------------------------------------------------------!
-      SUBROUTINE print_dimensions( indent_level, dimensions )
-
-         CHARACTER(LEN=50) ::  format1  !< format for write statements
-         CHARACTER(LEN=50) ::  format2  !< format for write statements
-
-         INTEGER             ::  i                        !< loop index
-         INTEGER, INTENT(IN) ::  indent_level             !< indentation level
-         INTEGER             ::  j                        !< loop index
-         INTEGER, PARAMETER  ::  max_keyname_length = 15  !< length of longest key name
-         INTEGER             ::  nelement                 !< number of elements to print
-
-         LOGICAL ::  is_masked  !< true if dimension is masked
-
-         TYPE(dimension_type), DIMENSION(:), INTENT(IN) ::  dimensions  !< list of dimensions
-
-
-         WRITE( format1, '(A,I3,A)' ) '(T', indent_level * indent_depth + 1, ',A'
-         WRITE( format2, '(A,I3,A,I3,A)' ) &
-            '(T', ( indent_level + 1 ) * indent_depth + 1, ',A,T', &
-            ( indent_level + 1 ) * indent_depth + 1 + max_keyname_length, ',(": ")'
-
-         WRITE( debug_output_unit, TRIM( format1 ) // ',A)' ) REPEAT( separation_string // ' ', 4 )
-         WRITE( debug_output_unit, TRIM( format1 ) // ')' ) 'dimensions:'
-
-         nelement = SIZE( dimensions )
-         DO  i = 1, nelement
-            is_masked = dimensions(i)%is_masked
-
-            !-- Print general information
-            WRITE( debug_output_unit, TRIM( format2 ) // ',A)' ) &
-               'name', TRIM( dimensions(i)%name )
-            WRITE( debug_output_unit, TRIM( format2 ) // ',A)' ) &
-               'type', TRIM( dimensions(i)%data_type )
-            WRITE( debug_output_unit, TRIM( format2 ) // ',I7)' ) &
-               'id', dimensions(i)%id
-            WRITE( debug_output_unit, TRIM( format2 ) // ',I7)' ) &
-               'length', dimensions(i)%length
-            WRITE( debug_output_unit, TRIM( format2 ) // ',I7,A,I7)' ) &
-               'bounds', dimensions(i)%bounds(1), ',', dimensions(i)%bounds(2)
-            WRITE( debug_output_unit, TRIM( format2 ) // ',L1)' ) &
-               'is masked', dimensions(i)%is_masked
-
-            !-- Print information about mask
-            IF ( is_masked )  THEN
-               WRITE( debug_output_unit, TRIM( format2 ) // ',I7)' ) &
-                  'masked length', dimensions(i)%length_mask
-
-               WRITE( debug_output_unit, TRIM( format2 ) // ',L1)', ADVANCE='no' ) &
-                  'mask', dimensions(i)%mask(dimensions(i)%bounds(1))
-               DO  j = dimensions(i)%bounds(1)+1, dimensions(i)%bounds(2)
-                  WRITE( debug_output_unit, '(A,L1)', ADVANCE='no' ) ',', dimensions(i)%mask(j)
-               ENDDO
-               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-
-               WRITE( debug_output_unit, TRIM( format2 ) // ',I6)', ADVANCE='no' ) &
-                  'masked indices', dimensions(i)%masked_indices(0)
-               DO  j = 1, dimensions(i)%length_mask-1
-                  WRITE( debug_output_unit, '(A,I6)', ADVANCE='no' ) &
-                     ',', dimensions(i)%masked_indices(j)
-               ENDDO
-               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-            ENDIF
-
-            !-- Print saved values
-            IF ( ALLOCATED( dimensions(i)%values_int8 ) )  THEN
-
-               WRITE( debug_output_unit, TRIM( format2 ) // ',I4)', ADVANCE='no' ) &
-                  'values', dimensions(i)%values_int8(dimensions(i)%bounds(1))
-               DO  j = dimensions(i)%bounds(1)+1, dimensions(i)%bounds(2)
-                  WRITE( debug_output_unit, '(A,I4)', ADVANCE='no' ) &
-                     ',', dimensions(i)%values_int8(j)
-               ENDDO
-               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-               IF ( is_masked )  THEN
-                  WRITE( debug_output_unit, TRIM( format2 ) // ',I4)', ADVANCE='no' ) &
-                     'masked values', dimensions(i)%masked_values_int8(0)
-                  DO  j = 1, dimensions(i)%length_mask-1
-                     WRITE( debug_output_unit, '(A,I4)', ADVANCE='no' ) &
-                        ',', dimensions(i)%masked_values_int8(j)
-                  ENDDO
-                  WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-               ENDIF
-
-            ELSEIF ( ALLOCATED( dimensions(i)%values_int16 ) )  THEN
-
-               WRITE( debug_output_unit, TRIM( format2 ) // ',I6)', ADVANCE='no' ) &
-                  'values', dimensions(i)%values_int16(dimensions(i)%bounds(1))
-               DO  j = dimensions(i)%bounds(1)+1, dimensions(i)%bounds(2)
-                  WRITE( debug_output_unit, '(A,I6)', ADVANCE='no' ) &
-                     ',', dimensions(i)%values_int16(j)
-               ENDDO
-               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-               IF ( is_masked )  THEN
-                  WRITE( debug_output_unit, TRIM( format2 ) // ',I6)', ADVANCE='no' ) &
-                     'masked values', dimensions(i)%masked_values_int16(0)
-                  DO  j = 1, dimensions(i)%length_mask-1
-                     WRITE( debug_output_unit, '(A,I6)', ADVANCE='no' ) &
-                        ',', dimensions(i)%masked_values_int16(j)
-                  ENDDO
-                  WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-               ENDIF
-
-            ELSEIF ( ALLOCATED( dimensions(i)%values_int32 ) )  THEN
-
-               WRITE( debug_output_unit, TRIM( format2 ) // ',I11)', ADVANCE='no' ) &
-                  'values', dimensions(i)%values_int32(dimensions(i)%bounds(1))
-               DO  j = dimensions(i)%bounds(1)+1, dimensions(i)%bounds(2)
-                  WRITE( debug_output_unit, '(A,I11)', ADVANCE='no' ) &
-                     ',', dimensions(i)%values_int32(j)
-               ENDDO
-               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-               IF ( is_masked )  THEN
-                  WRITE( debug_output_unit, TRIM( format2 ) // ',I11)', ADVANCE='no' ) &
-                     'masked values', dimensions(i)%masked_values_int32(0)
-                  DO  j = 1, dimensions(i)%length_mask-1
-                     WRITE( debug_output_unit, '(A,I11)', ADVANCE='no' ) &
-                        ',', dimensions(i)%masked_values_int32(j)
-                  ENDDO
-                  WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-               ENDIF
-
-            ELSEIF ( ALLOCATED( dimensions(i)%values_intwp ) )  THEN
-
-               WRITE( debug_output_unit, TRIM( format2 ) // ',I11)', ADVANCE='no' ) &
-                  'values', dimensions(i)%values_intwp(dimensions(i)%bounds(1))
-               DO  j = dimensions(i)%bounds(1)+1, dimensions(i)%bounds(2)
-                  WRITE( debug_output_unit, '(A,I11)', ADVANCE='no' ) &
-                     ',', dimensions(i)%values_intwp(j)
-               ENDDO
-               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-               IF ( is_masked )  THEN
-                  WRITE( debug_output_unit, TRIM( format2 ) // ',I11)', ADVANCE='no' ) &
-                     'masked values', dimensions(i)%masked_values_intwp(0)
-                  DO  j = 1, dimensions(i)%length_mask-1
-                     WRITE( debug_output_unit, '(A,I11)', ADVANCE='no' ) &
-                        ',', dimensions(i)%masked_values_intwp(j)
-                  ENDDO
-                  WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-               ENDIF
-
-            ELSEIF ( ALLOCATED( dimensions(i)%values_real32 ) )  THEN
-
-               WRITE( debug_output_unit, TRIM( format2 ) // ',E14.7)', ADVANCE='no' ) &
-                  'values', dimensions(i)%values_real32(dimensions(i)%bounds(1))
-               DO  j = dimensions(i)%bounds(1)+1, dimensions(i)%bounds(2)
-                  WRITE( debug_output_unit, '(A,E14.7)', ADVANCE='no' ) &
-                     ',', dimensions(i)%values_real32(j)
-               ENDDO
-               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-               IF ( is_masked )  THEN
-                  WRITE( debug_output_unit, TRIM( format2 ) // ',E14.7)', ADVANCE='no' ) &
-                     'masked values', dimensions(i)%masked_values_real32(0)
-                  DO  j = 1, dimensions(i)%length_mask-1
-                     WRITE( debug_output_unit, '(A,E14.7)', ADVANCE='no' ) &
-                        ',', dimensions(i)%masked_values_real32(j)
-                  ENDDO
-                  WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-               ENDIF
-
-            ELSEIF ( ALLOCATED( dimensions(i)%values_real64 ) )  THEN
-
-               WRITE( debug_output_unit, TRIM( format2 ) // ',E22.15)', ADVANCE='no' ) &
-                  'values', dimensions(i)%values_real64(dimensions(i)%bounds(1))
-               DO  j = dimensions(i)%bounds(1)+1, dimensions(i)%bounds(2)
-                  WRITE( debug_output_unit, '(A,E22.15)', ADVANCE='no' ) &
-                     ',', dimensions(i)%values_real64(j)
-               ENDDO
-               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-               IF ( is_masked )  THEN
-                  WRITE( debug_output_unit, TRIM( format2 ) // ',E22.15)', ADVANCE='no' ) &
-                     'masked values', dimensions(i)%masked_values_real64(0)
-                  DO  j = 1, dimensions(i)%length_mask-1
-                     WRITE( debug_output_unit, '(A,E22.15)', ADVANCE='no' ) &
-                        ',', dimensions(i)%masked_values_real64(j)
-                  ENDDO
-                  WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-               ENDIF
-
-            ELSEIF ( ALLOCATED( dimensions(i)%values_realwp ) )  THEN
-
-               WRITE( debug_output_unit, TRIM( format2 ) // ',E22.15)', ADVANCE='no' ) &
-                  'values', dimensions(i)%values_realwp(dimensions(i)%bounds(1))
-               DO  j = dimensions(i)%bounds(1)+1, dimensions(i)%bounds(2)
-                  WRITE( debug_output_unit, '(A,E22.15)', ADVANCE='no' ) &
-                     ',', dimensions(i)%values_realwp(j)
-               ENDDO
-               WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-               IF ( is_masked )  THEN
-                  WRITE( debug_output_unit, TRIM( format2 ) // ',E22.15)', ADVANCE='no' ) &
-                     'masked values', dimensions(i)%masked_values_realwp(0)
-                  DO  j = 1, dimensions(i)%length_mask-1
-                     WRITE( debug_output_unit, '(A,E22.15)', ADVANCE='no' ) &
-                        ',', dimensions(i)%masked_values_realwp(j)
-                  ENDDO
-                  WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-               ENDIF
-
-            ENDIF
-
-            IF ( ALLOCATED( dimensions(i)%attributes ) )  &
-               CALL print_attributes( indent_level+1, dimensions(i)%attributes )
-
-            IF ( i < nelement )  &
-               WRITE( debug_output_unit, TRIM( format1 ) // ')' ) separation_string
-         ENDDO
-
-      END SUBROUTINE print_dimensions
-
-      !--------------------------------------------------------------------------------------------!
-      ! Description:
-      ! ------------
-      !> Print list of variables.
-      !--------------------------------------------------------------------------------------------!
-      SUBROUTINE print_variables( indent_level, variables )
-
-         CHARACTER(LEN=50) ::  format1  !< format for write statements
-         CHARACTER(LEN=50) ::  format2  !< format for write statements
-
-         INTEGER             ::  i                        !< loop index
-         INTEGER, INTENT(IN) ::  indent_level             !< indentation level
-         INTEGER             ::  j                        !< loop index
-         INTEGER, PARAMETER  ::  max_keyname_length = 16  !< length of longest key name
-         INTEGER             ::  nelement                 !< number of elements to print
-
-         TYPE(variable_type), DIMENSION(:), INTENT(IN) ::  variables  !< list of variables
-
-
-         WRITE( format1, '(A,I3,A)' ) '(T', indent_level * indent_depth + 1, ',A'
-         WRITE( format2, '(A,I3,A,I3,A)' ) &
-            '(T', ( indent_level + 1 ) * indent_depth + 1, ',A,T', &
-            ( indent_level + 1 ) * indent_depth + 1 + max_keyname_length, ',(": ")'
-
-         WRITE( debug_output_unit, TRIM( format1 ) // ',A)' ) REPEAT( separation_string // ' ', 4 )
-         WRITE( debug_output_unit, TRIM( format1 ) // ')' ) 'variables:'
-
-         nelement = SIZE( variables )
-         DO  i = 1, nelement
-            WRITE( debug_output_unit, TRIM( format2 ) // ',A)' ) &
-               'name', TRIM( variables(i)%name )
-            WRITE( debug_output_unit, TRIM( format2 ) // ',A)' ) &
-               'type', TRIM( variables(i)%data_type )
-            WRITE( debug_output_unit, TRIM( format2 ) // ',I7)' ) &
-               'id', variables(i)%id
-            WRITE( debug_output_unit, TRIM( format2 ) // ',L1)' ) &
-               'is global', variables(i)%is_global
-
-            WRITE( debug_output_unit, TRIM( format2 ) // ',A)', ADVANCE='no' ) &
-               'dimension names', TRIM( variables(i)%dimension_names(1) )
-            DO  j = 2, SIZE( variables(i)%dimension_names )
-               WRITE( debug_output_unit, '(A,A)', ADVANCE='no' ) &
-                  ',', TRIM( variables(i)%dimension_names(j) )
-            ENDDO
-            WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-
-            WRITE( debug_output_unit, TRIM( format2 ) // ',I7)', ADVANCE='no' ) &
-               'dimension ids', variables(i)%dimension_ids(1)
-            DO  j = 2, SIZE( variables(i)%dimension_names )
-               WRITE( debug_output_unit, '(A,I7)', ADVANCE='no' ) &
-                  ',', variables(i)%dimension_ids(j)
-            ENDDO
-            WRITE( debug_output_unit, '(A)' )  ''  ! write line-end
-
-            IF ( ALLOCATED( variables(i)%attributes ) )  &
-               CALL print_attributes( indent_level+1, variables(i)%attributes )
-            IF ( i < nelement )  &
-               WRITE( debug_output_unit, TRIM( format1 ) // ')' ) separation_string
-         ENDDO
-
-      END SUBROUTINE print_variables
-
-END SUBROUTINE dom_database_debug_output
 
 !--------------------------------------------------------------------------------------------------!
@@ -662,14 +282,16 @@
 ! ------------
 !> Define output file.
-!--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_file( filename, format ) RESULT( return_value )
-
-   CHARACTER(LEN=*), INTENT(IN)           ::  filename  !< name of file to be created
-   CHARACTER(LEN=*), INTENT(IN), OPTIONAL ::  format    !< format of file to be created
+!> Example call:
+!>   status = dom_def_file( 'my_output_file_name', 'binary' )
+!--------------------------------------------------------------------------------------------------!
+FUNCTION dom_def_file( file_name, file_format ) RESULT( return_value )
+
+   CHARACTER(LEN=*), INTENT(IN) ::  file_name    !< name of file to be created
+   CHARACTER(LEN=*), INTENT(IN) ::  file_format  !< format of file to be created
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_file'  !< name of this routine
 
-   INTEGER(iwp) ::  f             !< loop index
-   INTEGER(iwp) ::  return_value  !< return value
+   INTEGER ::  f             !< loop index
+   INTEGER ::  return_value  !< return value
 
    TYPE(file_type), DIMENSION(:), ALLOCATABLE ::  files_tmp  !< temporary file list
@@ -678,21 +300,21 @@
    return_value = 0
 
-   CALL internal_message( 'debug', routine_name // ': define file "' // TRIM( filename ) // '"' )
+   CALL internal_message( 'debug', routine_name // ': define file "' // TRIM( file_name ) // '"' )
 
    !-- Allocate file list or extend it by 1
    IF ( .NOT. ALLOCATED( files ) ) THEN
 
-      nf = 1
-      ALLOCATE( files(nf) )
+      nfiles = 1
+      ALLOCATE( files(nfiles) )
 
    ELSE
 
-      nf = SIZE( files )
+      nfiles = SIZE( files )
       !-- Check if file already exists
-      DO  f = 1, nf
-         IF ( files(f)%name == TRIM( filename ) )  THEN
+      DO  f = 1, nfiles
+         IF ( files(f)%name == TRIM( file_name ) )  THEN
             return_value = 1
-            CALL internal_message( 'error', routine_name // ': file "' // TRIM( filename ) // &
-                                            '" already exists' )
+            CALL internal_message( 'error', routine_name // &
+                    ': file "' // TRIM( file_name ) // '" already exists' )
             EXIT
          ENDIF
@@ -701,10 +323,10 @@
       !-- Extend file list
       IF ( return_value == 0 )  THEN
-         ALLOCATE( files_tmp(nf) )
+         ALLOCATE( files_tmp(nfiles) )
          files_tmp = files
          DEALLOCATE( files )
-         nf = nf + 1
-         ALLOCATE( files(nf) )
-         files(:nf-1) = files_tmp
+         nfiles = nfiles + 1
+         ALLOCATE( files(nfiles) )
+         files(:nfiles-1) = files_tmp
          DEALLOCATE( files_tmp )
       ENDIF
@@ -714,10 +336,6 @@
    !-- Add new file to database
    IF ( return_value == 0 )  THEN
-      files(nf)%name = TRIM( filename )
-      IF ( PRESENT( format ) )  THEN
-         files(nf)%format = TRIM( format )
-      ELSE
-         files(nf)%format = TRIM( output_file_format )
-      ENDIF
+      files(nfiles)%name = TRIM( file_name )
+      files(nfiles)%format = TRIM( file_format )
    ENDIF
 
@@ -727,51 +345,71 @@
 ! Description:
 ! ------------
-!> Define dimension of type integer.
+!> Define dimension.
+!> Dimensions can either be limited (a lower and upper bound is given) or unlimited (only a lower
+!> bound is given). Also, instead of providing all values of the dimension, a single value can be
+!> given which is then used to fill the entire dimension.
+!> An optional mask can be given to mask limited dimensions.
+!> Example call:
+!>   - fixed dimension with 100 entries (values known):
+!>       status = dom_def_dim( file_name='my_output_file_name', dimension_name='my_dimension', &
+!>                             output_type='real32', bounds=(/1,100/), &
+!>                             values_real32=my_dim(1:100), mask=my_dim_mask(1:100) )
+!>   - fixed dimension with 50 entries (values not yet known):
+!>       status = dom_def_dim( file_name='my_output_file_name', dimension_name='my_dimension', &
+!>                             output_type='int32', bounds=(/0,49/), &
+!>                             values_int32=(/fill_value/) )
+!>   - masked dimension with 75 entries:
+!>       status = dom_def_dim( file_name='my_output_file_name', dimension_name='my_dimension', &
+!>                             output_type='real64', bounds=(/101,175/), &
+!>                             values_real64=my_dim(1:75), mask=my_dim_mask(1:75) )
+!>   - unlimited dimension:
+!>       status = dom_def_dim( file_name='my_output_file_name', dimension_name='my_dimension', &
+!>                             output_type='real32', bounds=(/1/), &
+!>                             values_real32=(/fill_value/) )
 !>
 !> @todo Convert given values into selected output_type.
 !--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_dim( filename, name, output_type, bounds,                   &
+FUNCTION dom_def_dim( file_name, dimension_name, output_type, bounds,        &
                       values_int8, values_int16, values_int32, values_intwp, &
                       values_real32, values_real64, values_realwp,           &
                       mask ) RESULT( return_value )
 
-   CHARACTER(LEN=*), INTENT(IN) ::  filename     !< name of file
-   CHARACTER(LEN=*), INTENT(IN) ::  name         !< name of dimension
-   CHARACTER(LEN=*), INTENT(IN) ::  output_type  !< data type of dimension variable in output file
+   CHARACTER(LEN=*), INTENT(IN) ::  file_name       !< name of file
+   CHARACTER(LEN=*), INTENT(IN) ::  dimension_name  !< name of dimension
+   CHARACTER(LEN=*), INTENT(IN) ::  output_type     !< data type of dimension variable in output file
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_dim'  !< name of this routine
 
-   INTEGER(iwp) ::  d             !< loop index
-   INTEGER(iwp) ::  f             !< loop index
-   INTEGER(iwp) ::  i             !< loop index
-   INTEGER(iwp) ::  j             !< loop index
-   INTEGER(iwp) ::  ndim          !< number of dimensions in file
-   INTEGER(iwp) ::  return_value  !< return value
-
-   INTEGER(iwp), DIMENSION(:), INTENT(IN) ::  bounds  !< lower and upper bound of dimension variable
-
-   INTEGER(KIND=1), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int8   !< values of dimension
-   INTEGER(KIND=2), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int16  !< values of dimension
-   INTEGER(KIND=4), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int32  !< values of dimension
-   INTEGER(iwp),    DIMENSION(:), INTENT(IN), OPTIONAL ::  values_intwp  !< values of dimension
-
-   LOGICAL, DIMENSION(:), INTENT(IN), OPTIONAL ::  mask  !< mask of dimesion
-
-   REAL(KIND=4), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_real32  !< values of dimension
-   REAL(KIND=8), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_real64  !< values of dimension
-   REAL(wp),     DIMENSION(:), INTENT(IN), OPTIONAL ::  values_realwp  !< values of dimension
-
-   TYPE(dimension_type) ::  dimension  !< new dimension
-
-   TYPE(dimension_type), DIMENSION(:), ALLOCATABLE ::  dims_tmp  !< temporary dimension list
+   INTEGER ::  d             !< loop index
+   INTEGER ::  f             !< loop index
+   INTEGER ::  i             !< loop index
+   INTEGER ::  j             !< loop index
+   INTEGER ::  ndims         !< number of dimensions in file
+   INTEGER ::  return_value  !< return value
+
+   INTEGER,         DIMENSION(:), INTENT(IN)           ::  bounds         !< lower and upper bound of dimension variable
+   INTEGER(KIND=1), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int8    !< values of dimension
+   INTEGER(KIND=2), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int16   !< values of dimension
+   INTEGER(KIND=4), DIMENSION(:), INTENT(IN), OPTIONAL ::  values_int32   !< values of dimension
+   INTEGER(iwp),    DIMENSION(:), INTENT(IN), OPTIONAL ::  values_intwp   !< values of dimension
+
+   LOGICAL,         DIMENSION(:), INTENT(IN), OPTIONAL ::  mask           !< mask of dimesion
+
+   REAL(KIND=4),    DIMENSION(:), INTENT(IN), OPTIONAL ::  values_real32  !< values of dimension
+   REAL(KIND=8),    DIMENSION(:), INTENT(IN), OPTIONAL ::  values_real64  !< values of dimension
+   REAL(wp),        DIMENSION(:), INTENT(IN), OPTIONAL ::  values_realwp  !< values of dimension
+
+   TYPE(dimension_type)                            ::  dimension       !< new dimension
+   TYPE(dimension_type), DIMENSION(:), ALLOCATABLE ::  dimensions_tmp  !< temporary dimension list
 
 
    return_value = 0
 
-   CALL internal_message( 'debug', routine_name //                  &
-                          ': define dimension "' // TRIM( name ) // &
-                          '" in file "' // TRIM( filename ) // '"' )
-
-   dimension%name      = TRIM( name )
+   CALL internal_message( 'debug', routine_name //                    &
+                          ': define dimension ' //                    &
+                          '(dimension "' // TRIM( dimension_name ) // &
+                          '", file "' // TRIM( file_name ) // '")' )
+
+   dimension%name      = TRIM( dimension_name )
    dimension%data_type = TRIM( output_type )
 
@@ -783,11 +421,12 @@
       !-- Set length to -1 as indicator.
       dimension%bounds(:) = bounds(1)
-      dimension%length    = -1_iwp
+      dimension%length    = -1
 
       IF ( PRESENT( mask ) )  THEN
          return_value = 1
-         CALL internal_message( 'error', routine_name //                              &
-                                         ': unlimited dimension "' // TRIM( name ) // &
-                                         '" in file "' // TRIM( filename ) // '" cannot be masked' )
+         CALL internal_message( 'error', routine_name //                      &
+                                ': unlimited dimensions cannot be masked ' // &
+                                '(dimension "' // TRIM( dimension_name ) //   &
+                                '", file "' // TRIM( file_name ) // '")!' )
       ENDIF
 
